package choco;

import org.chocosolver.solver.Model;
import org.chocosolver.solver.Solver;
import org.chocosolver.solver.variables.IntVar;
import static org.chocosolver.solver.search.strategy.Search.*;

/*
import org.chocosolver.solver.search.strategy.assignments.DecisionOperator; 
import org.chocosolver.solver.search.strategy.selectors.values.*;
import org.chocosolver.solver.search.strategy.selectors.variables.*;
*/

public class search_heuristics {
	public static void main(String[] args) {
		Model md = new Model("Testing Search Strategies");
		Solver sv = md.getSolver();
		
		IntVar v = md.intVar("v", 1, 2);
		IntVar w = md.intVar("w", 1, 3);
		IntVar x = md.intVar("x", 1, 4);
		IntVar y = md.intVar("y", 1, 5);
		IntVar z = md.intVar("y", 1, 6);
		
		IntVar [] X = new IntVar [] {v,w,x,y,z};
		IntVar [] Y = new IntVar [] {x,y,z};
		IntVar [] Z = new IntVar [] {v,w,z};
		
		md.allDifferent(X).post();
		
		int heur = 8;
			 if (heur ==  1) sv.setSearch(inputOrderLBSearch(Y), inputOrderLBSearch(Z));
		else if (heur ==  2) sv.setSearch(inputOrderLBSearch(Y), inputOrderUBSearch(Z)); 
		else if (heur ==  3) sv.setSearch(inputOrderUBSearch(Y), inputOrderLBSearch(Z));
		else if (heur ==  4) sv.setSearch(minDomLBSearch(X));
		else if (heur ==  5) sv.setSearch(minDomUBSearch(X));
		else if (heur ==  6) sv.setSearch(inputOrderLBSearch(Y), inputOrderUBSearch(Z)); 
		else if (heur ==  7) sv.setSearch(inputOrderUBSearch(Y), inputOrderLBSearch(Z));
		else if (heur ==  8) sv.setSearch(activityBasedSearch(X));
		//else if (heur ==  9) sv.setSearch(impactBasedSearch(X)); 
		else if (heur == 10) sv.setSearch(domOverWDegSearch(X));
		else if (heur == 11) sv.setSearch(inputOrderLBSearch(X));
		else if (heur == 12) sv.setSearch(inputOrderUBSearch(X));
		else if (heur == 13) sv.setSearch(intVarSearch(X));
		else if (heur == 14) sv.setSearch(randomSearch(X, 5));
		else if (heur == 15) sv.setSearch(randomSearch(X,5));
		
		sv.solve();
		
		System.out.print( " X = ");
		for (int i = 0; i < 5; i++) System.out.print(X[i].getValue()+ " ");
		System.out.println("");
	};
}
